include io.inc
include dos.inc
include dir.inc
include conio.inc
include stdio.inc
include stdlib.inc
include string.inc

MAXIDDSIZE equ 2048
OMF_THEADR equ 080h
OMF_COMENT equ 088h
OMF_PUBDEF equ 090h
OMF_LNAMES equ 096h
OMF_SEGDEF equ 098h
OMF_LEDATA equ 0A0h
OMF_FIXUPP equ 09Ch
OMF_MODEND equ 08Ah

OMF_FIXUPP32 equ 09Dh

S_OMFR		STRUC
o_type		db ?
o_length	dw ?
o_data		db MAXIDDSIZE dup(?)
o_cksum		db ?
S_OMFR		ENDS

	.data

cpinfo	db "Doszip Resource Compiler, Version 1.02 "
%      	db "&@Date",10,0
cpusage	db "USAGE: IDDC [-/options] <idd-file>",10
	db 10
	db " -mc   output 16-bit .compact",10
	db " -ml   output 16-bit .large (default)",10
	db " -mf   output 32-bit .flat",10
	db " -f#   full pathname of .OBJ file",10
	db " -t    compile text file (add zero)",10
	db 10,0

console	d? 0
public	console

omf	S_OMFR	<?>
fileidd	db WMAXPATH dup(?)
fileobj	db WMAXPATH dup(?)
idname	db '_IDD_'
dlname	db 128 dup(?)
dialog	db MAXIDDSIZE dup(?)
extobj	db '.obj',0
options	db "fmt",0
option_f db 0
option_m db 'l'	; -mc, -ml, -mf
option_t db 0

COMENT	db 88h,1Ch,00h,1Ah
	db 'Doszip Resource Edit v2.32',0
COMENT_SIZE = $ - COMENT

LNAMES	db 96h,0Dh,00h,00h
	db 4, 'DATA'
	db 5, '_DATA'
LNAMES_SIZE = $ - LNAMES

LNAMES32 db 96h,1Dh,00h,00h
	db 4, 'FLAT'
	db 4, 'CODE'
	db 5, '_TEXT'
	db 4, 'DATA'
	db 5, '_DATA'
LNAMES_SIZE32 = $ - LNAMES

	.code


omf_write:
	push esi
	mov rsi,offset omf
	assume	rsi:ptr S_OMFR
	xor eax,eax
	mov edx,eax
	movzx ecx,[rsi].o_length
	add ecx,2
	.repeat
	    lodsb
	    add edx,eax
	.untilcxz
	mov rsi,offset omf
	dec edx
	not edx
	movzx ebx,[rsi].o_length
	add ebx,2
	mov [rsi+rbx],dl
	inc ebx
	.if oswrite(rdi,dssi,rbx) != rbx
	    invoke perror,addr fileobj
	    invoke exit,2
	.endif
	pop esi
	assume rsi:nothing
	ret

arg_option_t:
	inc option_t
	ret

arg_option_f:
	inc option_f
	add ebx,2
	invoke strcpy,addr fileobj,dssi
	inc cl
	ret

arg_option_m:
	mov option_m,ah
	inc al
	ret

arg_option_?:
	invoke _print, addr cpinfo
	invoke _print, addr cpusage
	sub eax,eax
	ret

arg_option:
	mov eax,[rbx]
	.if al == '?'
	    jmp arg_option_?
	.endif
	.if al == '/' || al == '-'
	    shr eax,8
	    or  eax,202020h
	    push rbx
	    mov rbx,offset options
	  @@:
	    cmp al,[rbx]
	    je  @F
	    inc rbx
	    cmp byte ptr [rbx],0
	    jne @B
	    pop rbx
	    jmp arg_option_?
	  @@:
	    sub rbx,offset options
	    shl rbx,size_l/2
	    mov rcx,option_label[rbx]
	    pop rbx
	    jmp rcx
	.endif
	.if !fileidd
	    invoke strcpy,addr fileidd,ebx
	.else
	    jmp arg_option_?
	.endif
	sub eax,eax
	inc eax
	ret

	.data

option_label label size_t
	d? arg_option_f
	d? arg_option_m
	d? arg_option_t
	d? arg_option_?

	.code

main	proc c
	mov rdi,_argc
	mov esi,_argv
	.if rdi == 1
	    call arg_option_?
	    ret
	.endif
	dec rdi
	lodsd
	.repeat
	    lodsd
	    mov ebx,eax
	    call arg_option
	    .if ZERO?
	    	ret
	    .endif
	    dec rdi
	.until !rdi
	.if filexist(addr fileidd) != 1
	    invoke perror,addr fileidd
	    mov eax,1
	    ret
	.endif
	invoke strfn,addr fileidd
	invoke strcpy,addr dlname,dxax
	.if strrchr(dxax,'.')
	    mov rdi,rax
	    mov byte ptr [rdi],0
	.endif
	.if !option_f
	    invoke fullpath,addr fileobj,0
	    invoke strfn,addr fileidd
	    invoke strfcat,addr fileobj,0,dxax
	    invoke setfext,dxax,addr extobj
	.endif
	.if osopen(addr fileidd,_A_NORMAL,M_RDONLY,A_OPEN) == -1
	    invoke perror,fileidd
	    mov eax,2
	    ret
	.endif
	mov ebx,eax
	invoke osread,rbx,addr dialog,MAXIDDSIZE
	mov esi,eax
	invoke close,rbx
	.if !rsi
	    invoke perror,fileidd
	    mov eax,3
	    ret
	.endif
	.if option_t
	    inc rsi
	.endif
	.if rsi > 1020
	    invoke perror,"Resource is to big -- > 1024"
	    mov eax,3
	    ret
	.endif
	.if osopen(addr fileobj,_A_NORMAL,M_WRONLY,A_CREATETRUNC) == -1
	    invoke perror,addr fileobj
	    mov eax,2
	    ret
	.endif
	mov edi,eax
	invoke strfn,addr fileidd
	push16 dx
	push16 ax
	pop16 edx
	mov rdx,rax
	invoke strcpy,addr omf.o_data[1],edx
	invoke strlen,dxax
	mov omf.o_type,OMF_THEADR
	mov omf.o_data,al
	add eax,2
	mov omf.o_length,ax
	call omf_write
	invoke memcpy,addr omf,addr COMENT,COMENT_SIZE
	call omf_write
	.if option_m == 'f'
	    invoke memcpy,addr omf,addr LNAMES32,LNAMES_SIZE32
	.else
	    invoke memcpy,addr omf,addr LNAMES,LNAMES_SIZE
	.endif
	call omf_write
	mov eax,esi
	add eax,4
	mov omf.o_type,OMF_SEGDEF
	mov omf.o_length,7
	.if option_m == 'f'
	    mov omf.o_data,0A9h
	    mov omf.o_data[1],0
	    mov omf.o_data[2],0
	    mov omf.o_data[3],4
	    mov omf.o_data[4],3
	    mov omf.o_data[5],1
	.else
	    mov omf.o_data,48h
	    mov omf.o_data[1],al
	    mov omf.o_data[2],ah
	    mov omf.o_data[3],3
	    mov omf.o_data[4],2
	    mov omf.o_data[5],1
	.endif
	call omf_write
	.if option_m == 'f'
	    mov omf.o_type,OMF_COMENT
	    mov omf.o_length,5
	    mov omf.o_data,080h
	    mov omf.o_data[1],0FEh
	    mov omf.o_data[2],04Fh
	    mov omf.o_data[3],1
	    call omf_write
	    mov eax,esi
	    add eax,4
	    mov omf.o_type,OMF_SEGDEF
	    mov omf.o_length,7
	    mov omf.o_data,0A9h
	    mov omf.o_data[1],al
	    mov omf.o_data[2],ah
	    mov omf.o_data[3],6
	    mov omf.o_data[4],5
	    mov omf.o_data[5],1
	    call omf_write
	    mov omf.o_type,9Ah
	    mov omf.o_length,2
	    mov omf.o_data,02h
	    mov omf.o_data[1],62h
	    call omf_write
	.endif
	mov omf.o_type,OMF_PUBDEF
	.if option_m == 'f'
	    mov omf.o_data[0],1
	    mov omf.o_data[1],2
	.else
	    mov omf.o_data[0],0
	    mov omf.o_data[1],1
	.endif
	push16 ds
	push16 ax
	pop16 edx
	mov rdx,offset idname
	.if option_m != 'f'
	    inc edx
	.endif
	invoke strcpy,addr omf.o_data[3],edx
	invoke strlen,dxax
	mov omf.o_data[2],al
	add eax,7
	mov omf.o_length,ax
	mov ebx,eax
	mov eax,esi
	mov omf.o_data[rbx-4],al
	mov omf.o_data[rbx-3],ah
	mov omf.o_data[rbx-2],0
	mov omf.o_data[rbx-1],0
	call omf_write
	mov omf.o_type,OMF_COMENT
	mov omf.o_length,4
	mov omf.o_data,0
	mov omf.o_data[1],0A2h
	mov omf.o_data[2],1
	call omf_write
	invoke memzero,addr omf.o_data,1024
	mov eax,esi
	add eax,8
	mov omf.o_type,OMF_LEDATA
	mov omf.o_length,ax
	mov omf.o_data,1
	.if option_m == 'f'
	    inc omf.o_data
	.endif
	mov rcx,rsi
	.if option_t
	    dec rcx
	.endif
	invoke memcpy,addr omf.o_data[3],addr dialog,rcx
	call omf_write
	mov omf.o_type,OMF_FIXUPP
	.if option_m == 'f'
	    mov omf.o_type,OMF_FIXUPP32
	.endif
	mov omf.o_length,5
	mov eax,esi
	mov omf.o_data[1],al
	mov al,0CCh
	.if option_m == 'f'
	    mov al,0E4h
	.endif
	or  al,ah
	mov omf.o_data[0],al
	mov omf.o_data[2],54h
	mov omf.o_data[3],1
	.if option_m == 'f'
	    mov omf.o_data[3],2
	.endif
	mov  omf.o_data[4],0
	call omf_write
	mov omf.o_type,OMF_MODEND
	mov omf.o_length,2
	mov omf.o_data,0
	call omf_write
	invoke close,rdi
	sub eax,eax
	ret
main	endp

	end
